//+------------------------------------------------------------------+
//|                                                        Ich_1.mq5 |
//|                                                            Graff |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Graff"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//--- input parameters
input int      TenkanSen=9;
input int      KijunSen=26;
input int      SenkoSpan=52;
//uint ichi_h=0;
#include <Indicators\Trend.mqh>
CiIchimoku ichi;
uint ichi_h=0;

#include <ChartObjects\ChartObjectsArrows.mqh>
CChartObjectArrowDown down;
CChartObjectArrowUp up;

string prefix="Ich1_";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   ichi_h=iIchimoku(Symbol(),Period(),TenkanSen,KijunSen,SenkoSpan);
   ichi.Create(_Symbol,_Period,TenkanSen,KijunSen,SenkoSpan);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   IndicatorRelease(ichi_h);
   DeleteObjectPrefix(prefix);
   Comment("");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &High[],
                const double &Low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
//Comment(DoubleToString(ichi.TenkanSen(3),5));
   double tenkan[],kijun[],senkou_a[],senkou_b[];
// ichimoku
/**/   CopyBuf(ichi_h,0,tenkan);
   CopyBuf(ichi_h,1,kijun);
   CopyBuf(ichi_h,2,senkou_a);
   CopyBuf(ichi_h,3,senkou_b);
//ichi.Refresh(true);
//ichi.Refresh(false);
//ichi.RefreshCurrent(true);
//ichi.RefreshCurrent(false);
//for(int i=rates_total-1; i>=0; i--){
   int limit;
//---
   if(prev_calculated==0) limit=0;
   else                   limit=prev_calculated-1;
//---
   //ArrayResize(tenkan,rates_total-limit);
   //ArrayResize(kijun,rates_total-limit);
   for(int i=limit;i<rates_total;i++)
     {
      //--- tenkan sen
      //double high=Highest(High,TenkanSen,i);
      //double low=Lowest(Low,TenkanSen,i);
      //tenkan[i]=(high+low)/2.0;
      ////--- kijun sen
      //high=Highest(High,KijunSen,i);
      //low=Lowest(Low,KijunSen,i);
      //kijun[i]=(high+low)/2.0;
      //if(ichi.TenkanSen(i)>ichi.KijunSen(i))
      if(tenkan[i]>kijun[i])
        {// Bullish
         up.Create(0,prefix+"Tenkan>Kijun"+IntegerToString(i),0,time[i],Low[i]);
         up.Color(clrLimeGreen);
        }
      else
        {// Bearish
         down.Create(0,prefix+"Tenkan<Kijun"+IntegerToString(i),0,time[i],High[i]);
         down.Color(clrTomato);
        }
     }

   ArrayFree(tenkan);
   ArrayFree(kijun);
   ArrayFree(senkou_a);
   ArrayFree(senkou_b);
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
int CopyBuf(int handle,int bufnum,double &out[])
  {
   if(handle==INVALID_HANDLE)
     {
      Print("Inv hwd");
     }
   ArraySetAsSeries(out,true);
   return(CopyBuffer(handle,bufnum,0,TerminalInfoInteger(TERMINAL_MAXBARS),out));
  }
//+------------------------------------------------------------------+
void DeleteObjectPrefix(string pref)
  {
   int i=0;
   string objname;
   for(i=ObjectsTotal(0,0,-1)-1; i>=0; i--)
     {
      objname=ObjectName(0,i);
      if(StringFind(objname,pref)==-1) continue;
      else ObjectDelete(0,objname);
     }
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| get highest value for range                                      |
//+------------------------------------------------------------------+
double Highest(const double&array[],int range,int fromIndex)
  {
   double res=0;
//---
   res=array[fromIndex];
   for(int i=fromIndex;i>fromIndex-range && i>=0;i--)
     {
      if(res<array[i]) res=array[i];
     }
//---
   return(res);
  }
//+------------------------------------------------------------------+
//| get lowest value for range                                       |
//+------------------------------------------------------------------+
double Lowest(const double&array[],int range,int fromIndex)
  {
   double res=0;
//---
   res=array[fromIndex];
   for(int i=fromIndex;i>fromIndex-range && i>=0;i--)
     {
      if(res>array[i]) res=array[i];
     }
//---
   return(res);
  }
//+------------------------------------------------------------------+
